SystemOrganization addCategory: #MyTinyBlog!

Object subclass: #TBBlog
	instanceVariableNames: 'posts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyTinyBlog'!

TBBlog class
	instanceVariableNames: 'uniqueInstance'!

!TBBlog commentStamp: 'PamelaTAKOUNDOUM 4/17/2019 17:10' prior: 0!
Ma classe TBBlog définit mon blog qui est  constitué de posts!

TBBlog class
	instanceVariableNames: 'uniqueInstance'!

!TBBlog class methodsFor: 'as yet unclassified' stamp: 'PamelaTAKOUNDOUM 4/25/2019 16:54'!
createDemoPosts
	"TBBlog createDemoPosts"
	self current
	writeBlogPost: ((TBPost title: 'Welcome in TinyBlog' text: 'TinyBlog is a small blog engine made with Pharo.' category: 'TinyBlog') visible: true);
	
	writeBlogPost: ((TBPost title: 'Report Pharo Sprint' text: 'Friday, June 12 there was a Pharo sprint / Moose dojo. It was a nice event with more than 15 motivated sprinters. With the help of candies, cakes and chocolate, huge work has been done'
	
	category: 'Pharo') visible: true);

	writeBlogPost: ((TBPost title: 'Brick on top of Bloc - Preview' text: 'We are happy to announce the first preview version of Brick, a new widget set created from scratch on top of Bloc. Brick is being developed primarily by Alex Syrel (together with Alain Plantec, Andrei Chis and myself), and the work is sponsored by ESUG. Brick is part of the Glamorous Toolkit effort and will provide the basis for the new versions of the development tools.'

	category: 'Pharo') visible: true);

	writeBlogPost: ((TBPost title: 'The sad story of unclassified blog posts' text: 'So sad that I can read this.') visible: true);
 
	writeBlogPost: ((TBPost title: 'Working with Pharo on the Raspberry Pi' 
	
	text: 'Hardware is getting cheaper and many new small devices like the famous Raspberry Pi providecnew computation power that was one once only available on regular desktop computers.' 
	
	category: 'Pharo') 
	
	visible: true)! !

!TBBlog class methodsFor: 'accessing' stamp: 'PamelaTAKOUNDOUM 4/17/2019 17:14'!
current
"answer the instance of the TBRepository"
	^ uniqueInstance ifNil: [ uniqueInstance := self new ]! !

!TBBlog class methodsFor: 'class initialization' stamp: 'PamelaTAKOUNDOUM 4/17/2019 17:14'!
initialize
	self reset! !

TBBlog initialize!

!TBBlog class methodsFor: 'initialization' stamp: 'PamelaTAKOUNDOUM 4/17/2019 17:14'!
reset
	uniqueInstance := nil! !

!TBBlog methodsFor: 'as yet unclassified' stamp: 'PamelaTAKOUNDOUM 4/25/2019 16:28'!
allBlogPosts
	^ posts! !

!TBBlog methodsFor: 'as yet unclassified' stamp: 'PamelaTAKOUNDOUM 4/25/2019 16:42'!
allBlogPostsFromCategory: aCategory
	^ posts select: [ :p | p category = aCategory ]! !

!TBBlog methodsFor: 'private' stamp: 'PamelaTAKOUNDOUM 4/25/2019 16:49'!
allCategories
	^ (self allBlogPosts collect: [ :p | p category ]) asSet! !

!TBBlog methodsFor: 'as yet unclassified' stamp: 'PamelaTAKOUNDOUM 4/25/2019 16:40'!
allVisibleBlogPosts
	^ posts select: [ :p | p isVisible ]! !

!TBBlog methodsFor: 'as yet unclassified' stamp: 'PamelaTAKOUNDOUM 4/25/2019 16:45'!
allVisibleBlogPostsFromCategory: aCategory
	^ posts select: [ :p | p category = aCategory and: [ p isVisible ] ]! !

!TBBlog methodsFor: 'initialization' stamp: 'PamelaTAKOUNDOUM 4/17/2019 17:11'!
initialize
	super initialize.
	posts := OrderedCollection new.! !

!TBBlog methodsFor: 'removing' stamp: 'PamelaTAKOUNDOUM 4/25/2019 16:13'!
removeAllPosts
	posts := OrderedCollection new! !

!TBBlog methodsFor: 'accessing' stamp: 'PamelaTAKOUNDOUM 4/25/2019 16:14'!
size
	^ posts size! !

!TBBlog methodsFor: 'writing' stamp: 'PamelaTAKOUNDOUM 4/25/2019 16:13'!
writeBlogPost: aPost
	"Write the blog post in database"
	posts add: aPost! !

Object subclass: #TBPost
	instanceVariableNames: 'title text date category visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyTinyBlog'!

!TBPost commentStamp: 'PamelaTAKOUNDOUM 4/16/2019 16:50' prior: 0!
Mon Tiny Blog!

!TBPost class methodsFor: 'as yet unclassified' stamp: 'PamelaTAKOUNDOUM 4/16/2019 17:22'!
"Création d'un post sans préciser la catégorie"
title: aTitle text: aText
	^ self new
		title: aTitle;
		text: aText;
		yourself! !

!TBPost class methodsFor: 'as yet unclassified' stamp: 'PamelaTAKOUNDOUM 4/16/2019 17:24'!
"Création d'un post en précisant la catégorie"

title: aTitle text: aText category: aCategory
	^ (self title: aTitle text: aText)
		category: aCategory;
		yourself! !

!TBPost class methodsFor: 'as yet unclassified' stamp: 'PamelaTAKOUNDOUM 4/16/2019 17:16'!
unclassifiedTag 
 ^ 'Unclassified'! !

!TBPost methodsFor: 'action' stamp: 'PamelaTAKOUNDOUM 4/16/2019 17:12'!
beVisible 
	self visible: true! !

!TBPost methodsFor: 'accessing' stamp: 'PamelaTAKOUNDOUM 4/16/2019 16:56'!
category 
	^ category! !

!TBPost methodsFor: 'accessing' stamp: 'PamelaTAKOUNDOUM 4/16/2019 16:57'!
category: aString
	category := aString! !

!TBPost methodsFor: 'accessing' stamp: 'PamelaTAKOUNDOUM 4/16/2019 16:54'!
date 
	^ date! !

!TBPost methodsFor: 'accessing' stamp: 'PamelaTAKOUNDOUM 4/16/2019 16:56'!
date: aDate
	date := aDate! !

!TBPost methodsFor: 'initialization' stamp: 'PamelaTAKOUNDOUM 4/17/2019 14:54'!
initialize 
	self category: TBPost unclassifiedTag .
	self date: Date today.
	self notVisible 
! !

!TBPost methodsFor: 'class tests' stamp: 'PamelaTAKOUNDOUM 4/17/2019 14:51'!
isUnclassified 
	^ self category = TBPost unclassifiedTag ! !

!TBPost methodsFor: 'action' stamp: 'PamelaTAKOUNDOUM 4/16/2019 17:12'!
isVisible 
	^ visible! !

!TBPost methodsFor: 'action' stamp: 'PamelaTAKOUNDOUM 4/16/2019 17:13'!
notVisible
	self visible: false! !

!TBPost methodsFor: 'accessing' stamp: 'PamelaTAKOUNDOUM 4/16/2019 16:52'!
text 
	^ text! !

!TBPost methodsFor: 'accessing' stamp: 'PamelaTAKOUNDOUM 4/16/2019 16:53'!
text: aString
	text := aString! !

!TBPost methodsFor: 'accessing' stamp: 'PamelaTAKOUNDOUM 4/16/2019 16:50'!
title 
	^ title ! !

!TBPost methodsFor: 'accessing' stamp: 'PamelaTAKOUNDOUM 4/16/2019 16:52'!
title: aString
	title := aString ! !

!TBPost methodsFor: 'accessing' stamp: 'PamelaTAKOUNDOUM 4/16/2019 16:58'!
visible 
	^ visible! !

!TBPost methodsFor: 'accessing' stamp: 'PamelaTAKOUNDOUM 4/16/2019 17:06'!
visible: aBoolean
	visible := aBoolean
	! !

TBBlog initialize!
